var banner = {};
var tl;
var loop = 0;
var loopMax = 0;

function listen(evnt, elem, func) {
	if (elem.addEventListener)  // W3C DOM
		elem.addEventListener(evnt,func,false);
	else if (elem.attachEvent) { // IE DOM
		return elem.attachEvent("on"+evnt, func);
	}
}

listen("load", window, initAd);

function initAd() {

var learnmore = document.getElementById("cta_container");
	learnmore.addEventListener("mouseenter", onHoverOver);
	learnmore.addEventListener("mouseleave", onHoverOut);

	new TimelineMax().add(fadeIn_to(ad, 0.1));
	banner.start();
}

banner.start = function(){
	tl = new TimelineMax(/*{repeat:-1}*/)
	this.maintimeline();
}

/***************************/
/*** ANIMATION FUNCTIONS ***/
/***************************/

/*** GENERAL ***/

function fadeIn_to(a, dur) {
	return new TimelineMax()
		.to(a, dur, {autoAlpha:1});
}

function fadeIn(a, dur) {
	return new TimelineMax()
		.from(a, dur, {autoAlpha:0});
}

function fadeOut(a, dur) {
	return new TimelineMax()
		.to(a, dur, {autoAlpha:0});
}

function zoom_to() {
	new TimelineMax()
		.to(hero, 6, {scale:1.01, transformOrigin: '50% 56%', ease:Power1.easeInOut, rotation:0.1, force3D: true})
		.to(hero, 2, {delay: 0.25, scale:1.15, transformOrigin: '50% 70%', ease:Power1.easeInOut, rotation:0.1, force3D: true})
}

function slideInStop(a, dur) {
	return new TimelineMax()
		.from(a, dur, {x:'-=600px', ease:Power1.easeOut})
}

function slideOutStop(a, dur) {
	return new TimelineMax()
		.to(a, dur, {x:'-=600px', ease:Power1.easeInOut})
}

function pulse(a,dist) {
	return new TimelineMax({repeat:1})
		.to('#cta_arrow', 0.35, {x:-4, ease:Power1.easeInOut, force3D: true})
		.to('#cta_arrow', 0.35, {x:0, ease:Power1.easeInOut, force3D: true});
}

function onHoverOver(e){
	tm = TweenMax.fromTo('#cta_arrow', 0.35, {x:0, ease:Power1.easeInOut},{x:-4,repeat:-1, yoyo:true, ease:Power1.easeInOut, force3D: true});
}

function onHoverOut(e){
	tm.kill();
}

function onrepeat() {
	if(loop < loopMax) {
	    tl.play()
	} else {
	    tl.pause()
	}
	loop++;
}

/*********************/
/*** MAIN TIMELINE ***/
/*********************/

banner.maintimeline = function(){
	
	tl
		.set(hero, {scale:1.9})

		.call(zoom_to)
		.add(fadeIn_to(frame1, 0.25))
		
		.add(slideInStop(cta_container,1))

		.add(slideInStop(txt01_a,1),'+=0.25')
		.add(slideInStop(txt01_b,1),'-=.5')
		
		.add(slideOutStop([txt01_a,txt01_b],1),'+=2')
		
		.add(slideInStop(txt02_a,1),'+=0.25')
		.add(slideInStop(txt02_b,1),'-=0.5')

		.add(pulse(cta_arrow))
		//.call(onrepeat)	

		;
}